SystemOrganization addCategory: #Tarea2!

Object subclass: #Chess
	instanceVariableNames: 'torre dama peon caballo rey alfil casilleroBlanco otraImagen'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tarea2'!

!Chess methodsFor: 'operaciones con Imagenes' stamp: 'omarCubacordova 10/8/2012 07:21'!
alLado: aPicture de: bPicture
	"Devuelve una nueva figura poniendo la primera figura al lado de la 
      segunda "

	| pictureTemp imagen imagen2 linea cont |
	imagen := aPicture img copy.
	imagen2:=bPicture img.
	cont:=1.
	imagen
		do: [ :each |  linea:= imagen2 at:cont.
			imagen at:cont put: each,linea. cont:=cont+1].
		pictureTemp := Picture new.
		pictureTemp img:imagen.
	^ pictureTemp! !

!Chess methodsFor: 'piezas' stamp: 'OmarCuba 10/6/2012 18:28'!
alfil
	"Retorna el alfil"
  ^alfil! !

!Chess methodsFor: 'piezas' stamp: 'OmarCuba 10/6/2012 16:36'!
casilleroBlanco
	"Retorna el casilleroBlanco"
     ^casilleroBlanco! !

!Chess methodsFor: 'operaciones con Imagenes' stamp: 'omarCubacordova 10/8/2012 07:24'!
encima: aPicture de: bPicture
	"comment stating purpose of message"

	| pictureTemp imagen1  |
	imagen1 := aPicture img, bPicture img.
	pictureTemp:= Picture new.
	pictureTemp img: imagen1.
	^pictureTemp! !

!Chess methodsFor: 'operaciones con Imagenes' stamp: 'omarCubacordova 10/9/2012 05:33'!
espejoH: aPicture
	"retorna el espejo Horizontal de la imagen"

	| img pictureTemp cont |
	cont := aPicture img size.
	img:=aPicture img copy.
	aPicture img
		do: [ :each | 
			img at: cont put: each.
			cont := cont - 1 ].
	pictureTemp := Picture new.
	pictureTemp img: img.
	^ pictureTemp! !

!Chess methodsFor: 'operaciones con Imagenes' stamp: 'omarCubacordova 10/9/2012 06:08'!
espejoV: aPicture
	"retorna el espejo vertical de la imagen"

	| img pictureTemp cont cont2 lineaFinal |
	cont := 1.
	img:=aPicture img copy.
	aPicture img
		do: [ :linea |lineaFinal:=linea copy. cont2:=linea size.  linea  do: [:dato |  lineaFinal at:cont2 put:dato. cont2:=cont2-1].
			img at: cont put: lineaFinal.			
			cont := cont + 1 ].
	pictureTemp := Picture new.
	pictureTemp img: img.
	^ pictureTemp! !

!Chess methodsFor: 'as yet unclassified' stamp: 'omarCubacordova 10/9/2012 07:10'!
initialize
	"Metodo que inicia y crea las imagenes de peon caballo rey reyna alfil"

	|img1|
	casilleroBlanco:= Picture new.

img1:=#('__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________' '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________'    '__________________________________________________________'  '__________________________________________________________' '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________' '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________'    '__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________' '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________'    '__________________________________________________________'  '__________________________________________________________' '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________' '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'  '__________________________________________________________'   '__________________________________________________________'  '__________________________________________________________'    '__________________________________________________________'  '__________________________________________________________').
casilleroBlanco img:img1.

alfil:=Picture new.

img1:=# ('                                                          '  
       '                                                          '  
       '                                                          '  
       '                                                          '  
       '                            ##                            '  
       '                          ######                          '  
       '                         ###..###                         '  
       '                         ##....##                         '  
       '                         ##....##                         '  
       '                         ###..###                         '  
       '                          ######                          '  
       '                           ####                           '  
       '                         ########                         '  
       '                        ###....###                        '  
       '                      ####......####                      '  
       '                    ####..........####                    '  
       '                   ###..............###                   '  
       '                  ###................###                  '  
       '                 ###..................###                 '  
       '                ###.........##.........###                '  
       '                ##..........##..........##                '  
       '               ###..........##..........###               '  
       '               ##...........##...........##               '  
       '               ##.......##########.......##               '  
       '               ##.......##########.......##               '  
       '               ##...........##...........##               '  
       '               ##...........##...........##               '  
       '               ##...........##...........##               '  
       '               ###..........##..........###               '  
       '                ##..........##..........##                '  
       '                ###....................###                '  
       '                 ##....................###                '  
       '                 ###..................###                 '  
       '                  ###................###                  '  
       '                   ####################                   '  
       '                   ####################                   '  
       '                   ##................##                   '  
       '                  ###................###                  '  
       '                  ##..................##                  '  
       '                  ######################                  '  
       '                 ########################                 '  
       '                 ###..................###                 '  
       '                 #####..............#####                 '  
       '                 ########################                 '  
       '                      ##############                      '  
       '                          ######                          '  
       '                        ####..####                        '  
       '        ##################......##################        '  
       '      ##################..........##################      '  
       '    ####..........................................####    '  
       '    ###.....................##.....................###    '  
       '     ##...................######...................##     '  
       '     ###.########.......####  ####.......########.###     '  
       '      ####################      ####################      '  
       '       ##        #######          #######        ##       '  
       '                                                          '  
       '                                                          '  
       '                                                          ').
alfil img:img1.


otraImagen:=Picture new.

img1:=# (   '__________'  
                  '_____xxx__' 
                  '____xx____' 
                  '____xx____' 
                  '____xx____'
                  '___xxxx___' 
                  '___xxxx___' 
                  '_xxxxxxxx_' 
                  '_xxxxxxxx_'  
                  '__________'   
      ).
otraImagen img:img1.

torre:=Picture new.
img1:=# (   '__________'  
                  '__x_x_x___' 
                  '__xxxxx___' 
                  '____xx____' 
                  '____xx____'
                  '____xx____' 
                  '____xx____' 
                  '___xxxx___' 
                  '__xxxxxx__'  
                  '_xxxxxxxx_'   
      ).
torre img:img1








! !

!Chess methodsFor: 'operaciones con Imagenes' stamp: 'omarCubacordova 10/9/2012 06:56'!
invColor: aSimbol
	"Usada internamente para invertir el color de una figura "

	| val |
	val := aSimbol.
	 
	(aSimbol = $_)
		ifTrue: [ val := $= 		
			]
		ifFalse: [ 
			aSimbol = $=
				ifTrue: [ val := $_ ]
				ifFalse: [ 
					aSimbol = $.
						ifTrue: [ val := $@ ]
						ifFalse: [ 
							aSimbol = $@
								ifTrue: [ val := $. ] ] ] ].
	^ val! !

!Chess methodsFor: 'operaciones con Imagenes' stamp: 'omarCubacordova 10/9/2012 06:44'!
negativo: aPicture
	"Devuelve un negativo de la imagen "

	| img pictureTemp cont cont2 lineaFinal datoF |
	cont := 1.
	img := aPicture img copy.
	aPicture img
		do: [ :linea | 
			lineaFinal := linea copy.
			cont2 := 1.
			linea
				do: [ :dato | 
					datoF := self invColor: dato.
					lineaFinal at: cont2 put: datoF.
					cont2 := cont2 + 1 ].
			img at: cont put: lineaFinal.
			cont := cont + 1 ].
	pictureTemp := Picture new.
	pictureTemp img: img.
	^ pictureTemp! !

!Chess methodsFor: 'piezas' stamp: 'omarCubacordova 10/7/2012 08:28'!
otraImagen
	"retorna la otraImagen"

	^otraImagen! !

!Chess methodsFor: 'operaciones con Imagenes' stamp: 'omarCubacordova 10/9/2012 07:10'!
repetirH: aPicture veces:aNumber
	"comment stating purpose of message"

   |img pictureTemp cont lineaFinal cont2|
   img:=aPicture img copy.
   cont2:=1.
	
img  do: [:each | 
	lineaFinal:=each.

cont:=1.
[aNumber>cont] whileTrue:
[ 
	lineaFinal:=lineaFinal,each.
      cont:=cont+1
 ].
img at:cont2 put:lineaFinal.
cont2:=cont2+1.
].

pictureTemp:= Picture new.

pictureTemp img:img.
^ pictureTemp! !

!Chess methodsFor: 'operaciones con Imagenes' stamp: 'omarCubacordova 10/9/2012 07:11'!
repetirV: aPicture veces:aNumber

	"comment stating purpose of message"
	
   |img pictureTemp cont|

img:= aPicture img.
cont:=1.
[aNumber>cont] whileTrue:
[ img:=img,aPicture img.
cont:=cont+1 ].
pictureTemp:= Picture new.
pictureTemp img:img.
^ pictureTemp! !

!Chess methodsFor: 'operaciones con Imagenes' stamp: 'omarCubacordova 10/9/2012 07:03'!
superponer:aPicture en: bPicture
	"comment stating purpose of message"

	| temporary variable names |
! !

!Chess methodsFor: 'piezas' stamp: 'omarCubacordova 10/8/2012 06:50'!
torre
	"retorna la pieza torre"

	^ torre! !

Object subclass: #GUIChess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tarea2'!

!GUIChess methodsFor: 'as yet unclassified' stamp: 'omarCubacordova 10/9/2012 06:34'!
initialize
	"Metodo que inicia y crea el Chess"
	
	|chess pictureTemp|
	
	chess:=Chess new.
	"self visualizarPieza: chess casilleroBlanco."
	"self visualizarPieza: chess alfil."
	
	pictureTemp:=chess repetirV: chess torre   veces:3.
	
	self visualizarPieza:pictureTemp.
	
	pictureTemp:=chess repetirH: chess otraImagen   veces:4.
	
	self visualizarPieza: pictureTemp.
	
	pictureTemp:=chess espejoH: chess otraImagen.
	
	self visualizarPieza: pictureTemp.
	
	
	
	pictureTemp:=chess espejoV: chess otraImagen.
	
	self visualizarPieza: pictureTemp.
	
	
	pictureTemp:=chess alLado: chess otraImagen de: chess torre.
	
	self visualizarPieza: pictureTemp.
	pictureTemp:=chess encima: chess otraImagen de: chess torre.
	
	self visualizarPieza: pictureTemp.
	pictureTemp:=chess negativo: chess otraImagen.
	
	self visualizarPieza: pictureTemp.
	
	! !

!GUIChess methodsFor: 'as yet unclassified' stamp: 'omarCubacordova 10/7/2012 08:09'!
visualizarPieza:aPieza
	"Muestra la pieza solicitada"
	 |imagen|
	imagen:= aPieza img.
	imagen do: [:each |  Transcript show: each;cr].! !

Object subclass: #Picture
	instanceVariableNames: 'height width img'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tarea2'!

!Picture methodsFor: 'as yet unclassified' stamp: 'omarCubacordova 10/8/2012 07:55'!
= aPicture
	"comment stating purpose of message"

	| imagen |
	imagen:=aPicture img.
	^ self img = imagen
	! !

!Picture methodsFor: 'get_set' stamp: 'OmarCuba 10/6/2012 15:37'!
height
	"Retorna height"
	
	^height! !

!Picture methodsFor: 'get_set' stamp: 'OmarCuba 10/6/2012 15:41'!
img
	"Metodo Get de img"
 ^img
	! !

!Picture methodsFor: 'get_set' stamp: 'omarCubacordova 10/9/2012 07:27'!
img:aString
	"Metodo set de img"
	
	img:=aString.
	height := img size.
	img do: [:each | width:= each size]
 ! !

!Picture methodsFor: 'get_set' stamp: 'OmarCuba 10/6/2012 15:38'!
width
	"Retorna width"

 ^width! !

TestCase subclass: #TestChess
	instanceVariableNames: 'picture chess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tarea2'!

!TestChess methodsFor: 'running' stamp: 'omarCubacordova 10/9/2012 07:29'!
setUp
	"comment stating purpose of message"

	| img |
	img:=#('#.. '  '##= '   '###@'  ' ###').
	picture := Picture new.
	picture img:img.
	chess:= Chess new
! !

!TestChess methodsFor: 'running' stamp: 'omarCubacordova 10/8/2012 08:14'!
testAlLado
	"comment stating purpose of message"
	| body pPicture result |
	body := #('#.. #.. '   '##= ##= '   '###@###@'   ' ### ###').
	pPicture := Picture new.
	pPicture img: body.
	result := chess alLado: picture de: picture.
	self assert: pPicture = result! !

!TestChess methodsFor: 'running' stamp: 'omarCubacordova 10/8/2012 08:20'!
testEncima
	"comment stating purpose of message"

	| body pPicture result |
	body := #('#.. '   '##= '   '###@'   ' ###'  '#.. '   '##= '   '###@'   ' ###'  ).
	pPicture := Picture new.
	pPicture img: body.
	result := chess encima: picture de: picture.
	self assert: pPicture = result! !

!TestChess methodsFor: 'running' stamp: 'omarCubacordova 10/8/2012 08:04'!
testEspejoH
	"comment stating purpose of message"

	|body pPicture result|
	body:= #(' ###'  '###@'  '##= '  '#.. ').
	pPicture:= Picture new.
	pPicture img:body.
	result:=chess espejoH: picture.
	self assert:   pPicture = result
	
! !

!TestChess methodsFor: 'running' stamp: 'omarCubacordova 10/9/2012 05:32'!
testEspejoV
	"comment stating purpose of message"

	|body pPicture result|
	body:= #(' ..#'   ' =##'   '@###'   '### ').
	pPicture:= Picture new.
	pPicture img:body.
	result:=chess espejoV: picture.
	self assert:   pPicture = result
! !

!TestChess methodsFor: 'running' stamp: 'omarCubacordova 10/8/2012 07:41'!
testInit
	"comment stating purpose of message"

self assert: picture height = 4.
self assert: picture width = 4! !

!TestChess methodsFor: 'running' stamp: 'omarCubacordova 10/9/2012 06:58'!
testNegativo
	"comment stating purpose of message"

	| body pPicture result |
	body := #('#@@ '   '##_ '   '###.'   ' ###').
	pPicture := Picture new.
	pPicture img: body.
	result := chess negativo: picture.
	self assert: pPicture = result! !

!TestChess methodsFor: 'running' stamp: 'omarCubacordova 10/8/2012 08:07'!
testRepetirH
	"comment stating purpose of message"

	| body pPicture result |
	body := #('#.. #.. #.. '  '##= ##= ##= '  '###@###@###@'  ' ### ### ###').
	pPicture := Picture new.
	pPicture img: body.
	result := chess repetirH: picture veces:3.
	self assert: pPicture = result! !

!TestChess methodsFor: 'running' stamp: 'omarCubacordova 10/8/2012 08:11'!
testRepetirV
	"comment stating purpose of message"

	| body pPicture result |
	body := #('#.. '   '##= '   '###@'   ' ###'   '#.. '   '##= '   '###@'   ' ###'  
            '#.. '   '##= '   '###@'   ' ###').
	pPicture := Picture new.
	pPicture img: body.
	result := chess repetirV: picture veces: 3.
	self assert: pPicture = result! !
